﻿local MAJOR_VERSION = "Threat-1.0"
local MINOR_VERSION = tonumber(("$Revision: 38535 $"):match("%d+"))

if MINOR_VERSION > _G.ThreatLib_MINOR_VERSION then
	_G.ThreatLib_MINOR_VERSION = MINOR_VERSION
end

ThreatLib_funcs[#ThreatLib_funcs+1] = function()

local ThreatLib = _G.ThreatLib

local BB = AceLibrary("Babble-Boss-2.2")

-- You need to register the module with the localized mob name, as this is used to 
local c = BB["Kael'thas Sunstrider"]

local Kaelthas = ThreatLib:GetModule("NPCCore"):NewModule(c)

local phaseTriggerStrings = {
	["Thaladred"] = {
		["enUS"] = "Impressive. Let us see how your nerves hold up against the Darkener, Thaladred!",
		["deDE"] = nil,
		["frFR"] = "Impressionnant. Voyons comment tiendront vos nerfs face à l'Assombrisseur, Thaladred !",
		["koKR"] = "암흑의 인도자 탈라드레드를 상대로 얼마나 버틸지 볼까?",
		["zhTW"] = nil
	},
	["Sanguinar"] = {
		["enUS"] = "You have persevered against some of my best advisors... but none can withstand the might of the Blood Hammer. Behold, Lord Sanguinar!",
		["deDE"] = nil,
		["frFR"] = "Vous avez tenu tête à certains de mes plus talentueux conseillers… mais personne ne peut résister à la puissance du Marteau de sang. Je vous présente, le seigneur Sanguinar !",
		["koKR"] = "최고의 조언가를 상대로 잘도 버텨냈군. 허나 그 누구도 붉은 망치의 힘에는 대항할 수 없지. 보아라, 군주 생귀나르를!",
		["zhTW"] = nil
	},
	["Capernian"] = {
		["enUS"] = "Capernian will see to it that your stay here is a short one.",
		["deDE"] = nil,
		["frFR"] = "Capernian fera en sorte que votre séjour ici ne se prolonge pas.",
		["koKR"] = "카퍼니안, 놈들이 여기 온 것을 후회하게 해 줘라.",
		["zhTW"] = nil
	},
	["Telonicus"] = {
		["enUS"] = "Well done, you have proven worthy to test your skills against my master engineer, Telonicus.",
		["deDE"] = nil,
		["frFR"] = "Bien, vous êtes digne de mesurer votre talent à celui de mon maître ingénieur, Telonicus.",
		["koKR"] = "좋아, 그 정도 실력이면 수석기술자 텔로니쿠스를 상대해 볼만하겠어.",
		["zhTW"] = nil
	},
	["AllAdvisors"] = {
		["enUS"] = "Perhaps I underestimated you. It would be unfair to make you fight all four advisors at once, but... fair treatment was never shown to my people. I'm just returning the favor.",
		["deDE"] = nil,
		["frFR"] = "Peut-être vous ai-je sous-estimés. Il ne serait pas très loyal de vous faire combattre mes quatres conseillers en même temps, mais… mon peuple n'a jamais été traîté avec loyauté. Je ne fais que rendre la politesse.",
		["koKR"] = "네놈들을 과소평가했나 보군. 모두를 한꺼번에 상대하라는 건 불공평한 처사지. 나의 백성도 공평한 대접을 받은 적 없기는 매한가지. 받은 대로 돌려주겠다.",
		["zhTW"] = nil
	},
	["Weapons"] = {
		["enUS"] = "As you see, I have many weapons in my arsenal....",
		["deDE"] = nil,
		["frFR"] = "Comme vous le voyez, j'ai plus d'une corde à mon arc…",
		["koKR"] = "보다시피 내 무기고엔 굉장한 무기가 아주 많지.",
		["zhTW"] = nil
	},
	["Kael"] = {
		["enUS"] = "Alas, sometimes one must take matters into one's own hands. Balamore shanal!",
		["deDE"] = nil,
		["frFR"] = "Il est hélas parfois nécessaire de prendre les choses en main soi-même. Balamore shanal !",
		["koKR"] = nil,
		["zhTW"] = nil
	}
}

local weaponNames = {
	["Devastation"] = {
		["enUS"] = "Devastation",
		["deDE"] = nil,
		["frFR"] = "Dévastation",
		["koKR"] = "황폐의 도끼",
		["zhTW"] = nil
	},
	["Cosmic Infuser"] = {
		["enUS"] = "Cosmic Infuser",
		["deDE"] = nil,
		["frFR"] = "Bâton d'infusion cosmique",
		["koKR"] = "붕괴의 지팡이",
		["zhTW"] = nil
	},
	["Infinity Blades"] = {
		["enUS"] = "Infinity Blades",
		["deDE"] = nil,
		["frFR"] = "Lames d'infinité",
		["koKR"] = "무한의 비수",
		["zhTW"] = nil
	},
	["Staff of Disintegration"] = {
		["enUS"] = "Staff of Disintegration",
		["deDE"] = nil,
		["frFR"] = "Bâton de désintégration",
		["koKR"] = "우주 에너지 주입기",
		["zhTW"] = nil
	},
	["Warp Slicer"] = {
		["enUS"] = "Warp Slicer",
		["deDE"] = nil,
		["frFR"] = "Tranchoir dimensionnel",
		["koKR"] = "차원의 절단기",
		["zhTW"] = nil
	},
	["Netherstrand Longbow"] = {
		["enUS"] = "Netherstrand Longbow",
		["deDE"] = nil,
		["frFR"] = "Arc long brins-de-Néant",
		["koKR"] = "황천매듭 장궁",
		["zhTW"] = nil
	},
	["Phaseshift Bulwark"] = {
		["enUS"] = "Phaseshift Bulwark",
		["deDE"] = nil,
		["frFR"] = "Rempart de déphasage",
		["koKR"] = "위상 변화의 보루방패",
		["zhTW"] = nil
	},
}

local thaladredTrigger = phaseTriggerStrings["Thaladred"][_G.GetLocale()]
local sanguinarTrigger = phaseTriggerStrings["Sanguinar"][_G.GetLocale()]
local capernianTrigger = phaseTriggerStrings["Capernian"][_G.GetLocale()]
local telonicusTrigger = phaseTriggerStrings["Telonicus"][_G.GetLocale()]
local allAdvisorsTrigger = phaseTriggerStrings["AllAdvisors"][_G.Getlocale()]
local weaponTrigger = phaseTriggerStrings["Weapons"][_G.GetLocale()]
local kaelTrigger = phaseTriggerStrings["Kael"][_G.GetLocale()]

phaseTriggerStrings = nil

local weaponName = {
	["Devastation"] = weaponNames["Devastation"][_G.GetLocale()],
	["Cosmic Infuser"] = weaponNames["Cosmic Infuser"][_G.GetLocale()],
	["Infinity Blades"] = weaponNames["Infinity Blades"][_G.GetLocale()],
	["Staff of Disintigration"] = weaponNames["Staff of Disintigration"][_G.GetLocale()],
	["Warp Slicer"] = weaponNames["Warp Slicer"][_G.GetLocale()],
	["Netherstrand Longbow"] = weaponNames["Netherstrand Longbow"][_G.GetLocale()],
	["Phaseshift Bulwark"] = weaponNames["Phaseshift Bulwark"][_G.GetLocale()]
}

weaponNames = nil

local advisorDeathCount = 0
local weaponDeathCount = 0

function Kaelthas:Init()	
	self:RegisterCombatant(BB["Kael'thas Sunstrider"], true)
	self:RegisterCombatant(BB["Thaladred the Darkener"], self.advisorDeath)
	self:RegisterCombatant(BB["Lord Sanguinar"], self.advisorDeath)
	self:RegisterCombatant(BB["Grand Astromancer Capernian"], self.advisorDeath)
	self:RegisterCombatant(BB["Master Engineer Telonicus"], self.advisorDeath)
	
	if weaponName["Devastation"] and weaponName["Cosmic Infuser"] and weaponName["Infinity Blades"] and weaponName["Staff of Disintigration"] and weaponName["Warp Slicer"] and weaponName["Netherstrand Longbow"] and weaponName["Phaseshift Bulwark"] then
		self:RegisterCombatant(weaponName["Devastation"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Cosmic Infuser"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Infinity Blades"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Staff of Disintigration"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Warp Slicer"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Netherstrand Longbow"], self.weaponDeath)
		self:RegisterCombatant(weaponName["Phaseshift Bulwark"], self.weaponDeath)
	end
	-- To register a callback to a yell or emote:
	-- self:RegisterChatEvent([yell|event], localizedMobName, yellOrEmoteToTriggerOn, callbackFunction)
	
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], thaladredTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], sanguinarTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], capernianTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], telonicusTrigger, self.advisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], weaponTrigger, self.weaponTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], allAdvisorsTrigger, self.allAdvisorTransition)
	self:RegisterChatEvent("yell", BB["Kael'thas Sunstrider"], kaelTrigger, self.kaelTransition)
end

function Kaelthas:StartFight()
	self:SetNumberOfMobs(1)
end

function Kaelthas:advisorDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	advisorDeathCount = advisorDeathCount + 1
end

function Kaelthas:weaponDeath(victimName, killerName)
	self:WipeThreatOnMob(victimName)
	self:SetNumberOfMobs(self:GetNumberOfMobs() - 1)
	weaponDeathCount = weaponDeathCount + 1
end

function Kaelthas:advisorTransition()
	self:SetNumberOfMobs(1)
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:weaponTransition()
	self:SetNumberOfMobs(7)
	weaponDeathCount = 0
end

function Kaelthas:allAdvisorTransition()
	if weaponDeathCount == 7 then
		self:SetNumberOfMobs(4)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 4)
	end
	advisorDeathCount = 0
	self:WipeRaidThreatOnMob(BB["Thaladred the Darkener"])
	self:WipeRaidThreatOnMob(BB["Lord Sanguinar"])
	self:WipeRaidThreatOnMob(BB["Grand Astromancer Capernian"])
	self:WipeRaidThreatOnMob(BB["Master Engineer Telonicus"])
end

function Kaelthas:kaelTransition()
	if weaponDeathCount == 7 and advisorDeathCount == 4 then
		self:SetNumberOfMobs(1)
	else
		self:SetNumberOfMobs(self:GetNumberOfMobs() + 1)
	end
	self:WipeRaidThreatOnMob(BB["Kael'thas Sunstrider"])
end

table.insert(ThreatLib.UpvalueFixers, function(lib)
	ThreatLib = lib
	Kaelthas = ThreatLib:GetModule("NPCCore"):GetModule(c)
end)

end
